Skip to main content

teeny_http/
download.rs

1/*
2 * Copyright (c) 2026 Teenygrad.
3 *
4 * Licensed under the Apache License, Version 2.0 (the "License");
5 * you may not use this file except in compliance with the License.
6 * You may obtain a copy of the License at
7 *
8 *   http://www.apache.org/licenses/LICENSE-2.0
9 *
10 * Unless required by applicable law or agreed to in writing, software
11 * distributed under the License is distributed on an "AS IS" BASIS,
12 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 * See the License for the specific language governing permissions and
14 * limitations under the License.
15 */
16
17use reqwest::header::HeaderMap;
18
19use crate::{
20    error::{Error, Result},
21    fetch::fetch_content,
22};
23use std::{fs::File, io::Write, path::Path};
24
25/// Fetches `url` and writes the response body to `path.join(name)`, optionally showing a
26/// progress bar (see [`crate::fetch::fetch_content`]).
27pub async fn download_file(
28    name: &str,
29    url: &str,
30    path: &Path,
31    headers: Option<HeaderMap>,
32    show_progress: bool,
33) -> Result<()> {
34    let mut file = File::create(path.join(name)).map_err(Error::FileCreateFailed)?;
35    let content = fetch_content(name, url, headers, show_progress).await?;
36    file.write_all(&content).map_err(Error::FileWriteFailed)?;
37
38    Ok(())
39}